      TITLE   'Mastercrd.ASM'
       LIST    P=16F84
 
IO_PIN EQU 007H ;SET INPUT / OUTPUT PIN
;
IO_MASK = 0FFH & ~(1 << IO_PIN)
 
 
CY      EQU     0       ; Carry/borrow bit
DC      EQU     1       ; Digit carry
Z       EQU     2       ; Zero flag
PD      EQU     3       ; Power down
T0      EQU     4       ; Time-out bit
RP0     EQU     5       ; Register page select bits
RP1     EQU     6       ; Not used in 16C84
RP2     EQU     7       ; Not used in 16C84
INDIR   EQU     00H     ; Indirect pointer
RTCC    EQU     01H     ; Real time clock / counter
PCL     EQU     02H     ; Program counter low byte
STATUS  EQU     03H     ; Status register
FSR     EQU     04H     ; Indirect pointer
PORTA   EQU     05H     ; PORT A
PORTB   EQU     06H     ; PORT B
PORTC   EQU     07H     ; PORT C
EEDATA  EQU     08H     ; Eeprom data
EEADR   EQU     09H     ; Eeprom address
PCLATH  EQU     0AH     ; Program counter high byte
INTCON  EQU     0BH     ; Interrupt control
TRISA   EQU     085H    ; Data direction port A
TRISB   EQU     086H    ; Data direction port B
EECON1  EQU     088H    ; Eeprom control
W       EQU     0       ; W reg. as destination
F       EQU     1       ; F file as destination
 
 
SCLK    EQU     5      ;SERIAL EEPROM CLOCK LINE
SDATA   EQU     4      ;SERIAL EEPROM DATA LINE
 
;---------------------------------------------
; Variablen Deffinition
;---------------------------------------------
 
rb0     equ     00H     ; i/o card 0
rb1     equ     01H     ; i/o card 1
rb2     equ     02H     ; switch card 1
rb3     equ     03H     ; switch card 1
rb4     equ     04H     ; i/o card 2
rb5     equ     05H     ; usato dal soft originale (mantenuto per compatibilita')
rb6     equ     06H     ; switch card 2
rb7     equ     07H     ; i/o CAM
 
             ORG 0000H
 
              GOTO     Start
              NOP
              NOP
              NOP
              RETFIE
 
L0005         CLRF     0DH
              BCF      STATUS,CY
              MOVLW    08H
              MOVWF    0FH
L0009         RLF      EEDATA,F
              BTFSS    STATUS,CY
              GOTO     L000D
              INCF     0DH,F
L000D         DECFSZ   0FH,F
              GOTO     L0009
              RLF      EEDATA,F
              RETURN
 


;######################################################
;	Sent Byte to Reciver
;######################################################
Send_Bytes    MOVF     017H,W
Send_Byte     MOVWF    EEDATA
              CALL     L0005
              MOVLW    07FH
              TRIS     PORTB
              BCF      PORTB,rb7
              NOP
              NOP
              MOVLW    09H
              MOVWF    0FH
              CALL     Schleife_A
              RRF      0DH,F
L001D         RRF      EEDATA,F
              BTFSC    STATUS,CY
              GOTO     L0023
              NOP
              BCF      PORTB,rb7
              GOTO     L0026
L0023         BSF      PORTB,rb7
              NOP
              NOP
L0026         CALL     Schleife_A
              DECFSZ   0FH,F
              GOTO     L001D
              NOP
              NOP
              NOP
              NOP
              NOP
              BSF      PORTB,rb7
              MOVLW    0FFH
              TRIS     PORTB
              MOVLW    059H
              CALL     Schleife_B
              RETURN
 
;######################################################
;	Read Byte from Reciver
;######################################################
Read_Byte     BTFSC    PORTB,rb7
              GOTO     Read_Byte
              ;MOVLW    02AH
              MOVLW    020H
              CALL     Schleife_B
              MOVLW    08H
              MOVWF    0FH
L003D         RRF      EEDATA,F
              BTFSS    PORTB,rb7
              GOTO     L0041
              GOTO     L0043
L0041         BCF      EEDATA,rb7
              GOTO     L0045
L0043         BSF      EEDATA,rb7
              NOP
L0045         CALL     Schleife_A
              DECFSZ   0FH,F
              GOTO     L003D
              MOVLW    051H
              CALL     Schleife_B
              MOVF     EEDATA,W
              RETURN

;######################################################
;	Schleife.... 011H wird runtergezhlt
;######################################################
Schleife_A    MOVLW    01AH
Schleife_B    MOVWF    011H
L004E         DECFSZ   011H,F
              GOTO     L004E
              RETURN
 

;######################################################
;	Grosse Schleife.... 011H & 0FH werden runtergezhlt
;######################################################
grosse_Schleife   MOVLW    02AH
              MOVWF    0FH
L0053         CALL     Schleife_A
              DECFSZ   0FH,F
              GOTO     L0053
              RETURN
 
Start         CLRF     FSR
              BSF      STATUS,RP0
              BCF      RTCC,rb7
              BCF      STATUS,RP0
              MOVLW    0FFH
              TRIS     PORTA
              MOVLW    0FFH
              TRIS     PORTB
              MOVWF    PORTA
              MOVWF    PORTB
              CALL     grosse_Schleife
              CLRF     0CH
;sende ATR-----------------------------------
              MOVLW    00H
              MOVWF    EEADR
              MOVLW    0EH
              MOVWF    01AH
              GOTO     send_eedata
;--------------------------------------------
 
String_ret    MOVLW    090H
              CALL     Send_Byte
              MOVLW    00H
              CALL     Send_Byte

String_abfr   CALL     Read_Byte	;lese 1. Byte (class)
              MOVWF    016H		;bergebe class an 016H
              XORLW    0C1H		;vergleiche ob class=c1 ist
              BTFSS    STATUS,Z		;wenn NICHT, dan springe nach string_abfr
              GOTO     String_abfr
              CALL     Read_Byte	;lese 2. Byte (INST)
              MOVWF    017H		;bergebe das Byte an Flagreg. 017H
              CALL     Read_Byte	;lese 3. Byte (P1)
              MOVWF    018H		;bergebe das byte an Flagreg. 018H
              CALL     Read_Byte	;lese 4. Byte (P2)
              MOVWF    019H		;bergebe das byte an Flagreg. 019H
              CALL     Read_Byte	;lese 5. Byte (Lnge)
              MOVWF    01AH		;bergebe das byte an Flagreg. 01AH
              ;CALL     Schleife_A	;wait.....

;-----berprfen der INST Anweisungen--------------------------------

              MOVF     017H,W
              XORLW    0FFH		;berprfe ob INST = FF ist (Schreibe EEPRM inhalt)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_FF

              MOVF     017H,W
              XORLW    00H		;berprfe ob INST = 00 ist (Lese EEPRM inhalt)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_00

              MOVF     017H,W
              XORLW    0EH		;berprfe ob INST = 0E ist (Antw. Seriennummer)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_0E
 
              MOVF     017H,W
              XORLW    01AH		;berprfe ob INST = 1A ist (Ausl. Keyindiz) 
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_1A
 
              MOVF     017H,W
              XORLW    012H		;berprfe ob INST = 12 ist (Antw. Provider ID)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_12
 
              MOVF     017H,W
              XORLW    016H		;berprfe ob INST = 16 ist (Antw. Anzahl Provider)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_16
 
              MOVF     017H,W
              XORLW    030H		;berprfe ob INST = 30 ist (PPV-Transaktion)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_30
 
              MOVF     017H,W
              XORLW    032H		;berprfe ob INST = 32 ist (Datenanforderung)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_32
 
              MOVF     017H,W
              XORLW    034H		;berprfe ob INST = 34 ist (spez. datenanforderung)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_34
 
              MOVF     017H,W
              XORLW    03AH		;berprfe ob INST = 3A ist (ECM Entschl. Contr. Words)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_3A
 
              MOVF     017H,W
              XORLW    03CH		;berprfe ob INST = 3C ist (Verwendung von Keys)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_3C
 
              MOVF     017H,W
              XORLW    040H		;berprfe ob INST = 40 ist (EMM Abonnementsverwaltung)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_40
 
              MOVF     017H,W
              XORLW    05AH		;berprfe ob INST = 5A ist (Ausl. vom Ciphertext)
              BTFSC    STATUS,Z		;wenn nicht dann nchster schritt
              GOTO     INST_5A
 
              MOVLW    06DH
              CALL     Send_Byte
              MOVLW    00H
              CALL     Send_Byte
              GOTO     String_abfr
;------------------------------------------------------------------

L00E1         CALL     Read_Byte
              DECFSZ   01AH,F
              GOTO     L00E1
              RETURN
 
;---------Auslesen des EEPROMs-------------------------------------
INST_00       Call     Read_Byte
              MOVLW    0C1H
              CALL     Send_Byte
              MOVLW    0FFH
              CALL     Send_Byte
              MOVF     018H,W
              MOVWF    0CH
              RLF      0CH,F
              CALL     Send_Byte
              MOVF     019H,W
              MOVWF    EEADR
              CALL     Send_Byte
              MOVF     01AH,W
              CALL     Send_Byte
loop_00       CALL     Read_EE1
              CALL     Send_Byte
              DECFSZ   01AH,F
              GOTO     loop_00
              MOVLW    090H
              CALL     Send_Byte
              GOTO     String_abfr
;------------------------------------------------------------------

;----------EEPROM beschreiben-------------------------------------
INST_FF       MOVF     018H,W
              MOVWF    0CH
              RLF      0CH,F
              MOVF     019H,W
              MOVWF    EEADR
              MOVF     01AH,W
              MOVWF    01BH
              MOVLW    01CH
              MOVWF    FSR
loop_FF       CALL     Read_Byte
              MOVWF    INDIR
              INCF     FSR,F
              DECFSZ   01AH,F
              GOTO     loop_FF
              CALL     Read_Byte
              MOVLW    01CH
              MOVWF    FSR
loop_FF2      MOVF     INDIR,W
              MOVWF    EEDATA
              CALL     Rewrite
              INCF     FSR,F
              DECFSZ   01BH,F
              GOTO     loop_FF2
              GOTO     String_ret
;------------------------------------------------------------------

;-------Auslesen Key Indiz-----------------------------------------
INST_1A       CALL     Send_Bytes	;sende 1A
              CLRF     0CH		;setze EEPROM High Adressbyte auf 00 
              MOVLW    060H		;setze EEPROM Low Adressbyte auf 60
              MOVWF    EEADR
              GOTO     send_eedata
;------------------------------------------------------------------
 
;-------Auslesen vom Ciphertest------------------------------------
INST_5A       CALL     Send_Bytes	;sende 5A
              CLRF     0CH		;setze EEPROM High Adressbyte auf 00 
              MOVLW    090H		;setze EEPROM Low Adressbyte auf 90
              MOVWF    EEADR
              CALL     send_EE_Data	;sende die daten aus dem EEPROM
              MOVLW    090H		;sende die beiden Bytes 90 1D
              CALL     Send_Byte
              MOVLW    01DH
              CALL     Send_Byte
              GOTO     String_abfr
;------------------------------------------------------------------

;------Abfrage der Seriennummer der Karte--------------------------
INST_0E       CALL     Send_Bytes	;sende 0E
              CLRF     0CH		;setze EEPROM High Adressbyte auf 00
              MOVLW    040H		;setze EEPROM Low Adressbyte auf 40
              MOVWF    EEADR
              GOTO     send_eedata	;sende die daten aus dem EEPROM
;------------------------------------------------------------------
 
;-------Abfrage Provider ID----------------------------------------
INST_12       CALL     Send_Bytes	;sende 12
              MOVLW    010H		;setze EEPROM Low Adressbyte auf 10
              MOVWF    EEADR
              CALL     Key_highbyte	;werte P1 aus und setze dementsprechend die EEPROM High Adresse
              GOTO     send_eedata	;sende die daten aus dem EEPROM
;------------------------------------------------------------------

;-------Antwort Anzahle der provider-------------------------------
INST_16       CALL     Send_Bytes	;sende 16
              CLRF     0CH		;setze EEPROM High Adressbyte auf 00
              MOVLW    050H		;setze EEPROM Low Adressbyte auf 50
              MOVWF    EEADR
              GOTO     send_eedata	;sende die daten aus dem EEPROM
;------------------------------------------------------------------
 
;---------Pay per View Transaktion---Passwortabfr---
INST_30       CALL     Send_Bytes	;sende Byte 30
              CALL     L00E1		;lese alle nachfolgenden Bytes aus
              GOTO     String_ret	;springe zur Abfrage zurck und Antworte mit 90 00
;------------------------------------------------------------------

;---------Datenanforderung------Wird erst nach INST 34 Aufgerufen--
;Daten 044H = 00 es folgen Package Bitmaps
;             01 es folgen Credit Records
;             03 es folgen PPV Records
;             04 es folgen SECA Records
;             06 es folgen bel. Records

INST_32       CALL     Send_Bytes	;sende Byte 32
              MOVF     044H,W
              XORLW    04H		;ist es ein SECA Record, dann springe zu SECA_rec
              BTFSC    STATUS,Z
              GOTO     SECA_rec
              MOVF     01AH,W
              XORLW    0DH
              BTFSC    STATUS,Z
              GOTO     lang_0D

              MOVLW    00H		;setze EEPROM Low Adresse auf 00
              MOVWF    EEADR
              CALL     Key_highbyte	;werte P1 aus und setze dementsprechend die EEPROM High Adresse
              MOVF     01AH,W
              MOVWF    01BH
              MOVLW    010H
              MOVWF    01AH
              CALL     send_EE_Data	;sende die daten aus dem EEPROM
              MOVF     01BH,W
              ADDLW    0F0H
              MOVWF    01AH
loop_32       MOVLW    0FFH
              CALL     Send_Byte
              DECFSZ   01AH,F
              GOTO     loop_32
              GOTO     String_ret
lang_0D       CLRF     0CH		;setze EEPROM High Adressbyte auf 00
              MOVLW    010H		;setze EEPROM Low Adressbyte auf 10
              MOVWF    EEADR
              GOTO     send_eedata	
SECA_rec      CLRF     0CH		;setze EEPROM High Adressbyte auf 00H
              MOVLW    080H		;setze EEPROM High Adressbyte auf 080H
              MOVWF    EEADR
              GOTO     send_eedata
;------------------------------------------------------------------

;----spez. Datenanforderung----C1 34 00 00 03 44 45 46 ------------
INST_34       CALL     Send_Bytes	;sende Byte 34
              CALL     Read_Byte	;Lese 1. Byte nach der lngenangabe
              MOVWF    044H		;speichere es in Flagregister 044H ab
              CALL     Read_Byte	;Lese 2. Byte nach der Lngenangabe
              MOVWF    045H		;speichere es in Flagregister 045H ab
              CALL     Read_Byte	;Lese 3. Byte nach der Lngenangabe
              MOVWF    046H		;speichere es in Flagregister 046H ab
              GOTO     String_ret	; sende 90 00 und frage erneut ab
;------------------------------------------------------------------
 
;-------ECM Entschlsselte Control Words --------------------------
INST_3A       CALL     Send_Bytes	;sende Byte 3A
              MOVLW    01CH		;setze Pointer auf 01CH im Pointer Flagregister
              MOVWF    FSR
Loop_3A       MOVF     INDIR,W		;Hohle Wert aus dem mit dem pointer makierten Stack
              CALL     Send_Byte	;sende dieses Byte
              INCF     FSR,F		;erhhe Pointer um 1
              DECFSZ   01AH,F		;Lnge = Lnge - 1
              GOTO     Loop_3A		;lese solange den Stack aus, bis lnge=0
              GOTO     String_ret
;------------------------------------------------------------------

;--------Verwendung von Keys---------------------------------------
INST_3C       CALL     Send_Bytes	;sende Byte 3C
Loop_3C       CALL     Read_Byte	;lese Byte nach der Lngenangabe
              DECF     01AH,F		;Lnge = Lnge -1
              XORLW    0D1H		;ist Byte=D1 dann mach weiter, ansonsten wiederhole lesevorgang
              BTFSS    STATUS,Z
              GOTO     Loop_3C		;frage erneut ab
              CALL     read_D1_Key
              CALL     L00E1
              CALL     get_16byte_key
              CALL     L0247
              CALL     L032D
              CALL     L024F
              CALL     L024B
              CALL     L032D
              CALL     L0253
              GOTO     String_ret
;------------------------------------------------------------------


;--------Read 16 Bytes key nach dem Nano D1 aus dem INST 3C--
read_D1_Key         MOVLW    010H		;lese 16 Byte nach dem Nano D1 aus
              MOVWF    013H			;und speichere sie ab dem Flagregister 01CH ab
              MOVLW    01CH			;01CH - 02CH = 16 Bytes Keys
              MOVWF    FSR
loopD1         CALL     Read_Byte
              DECF     01AH,F
              MOVWF    INDIR
              INCF     FSR,F
              DECFSZ   013H,F
              GOTO     loopD1
              RETURN
;------------------------------------------------------------------
 
;-------INST 40 Opperationen EMMs-------------------
INST_40       CALL     Send_Bytes	;sende Byte 40
              MOVLW    081H
              XORWF    019H,W		;teste ob P2 = 81 ist
              BTFSS    STATUS,Z	
              GOTO     antw_901D	;wenn nicht, beantworte den String mit 90 1D
              MOVLW    04EH
              XORWF    01AH,W		;teste ob lnge 4E betrgt
              BTFSS    STATUS,Z
              GOTO     antw_901D	;wenn nicht, beantworte den String mit 90 1D

              MOVLW    020H		;lese die ersten 020H Bytes aus.....
              MOVWF    04BH
L0187         CALL     Read_Byte
              DECF     01AH,F
              DECFSZ   04BH,F
              GOTO     L0187

              MOVF     01AH,W		;lese die letzten 02EH Bytes aus.....
              MOVWF    013H		;und speichere sie ab Flagregister 01CH ab
              MOVLW    01CH
              MOVWF    FSR
L018F         CALL     Read_Byte
              MOVWF    INDIR
              INCF     FSR,F
              DECFSZ   013H,F
              GOTO     L018F

              MOVF     01AH,W		;hole alle Daten ab dem Flagreg. 01CH
              MOVWF    013H		;und lege diese in den PIC EEPROM ab (adresse 00)
              MOVLW    01CH
              MOVWF    FSR
              CLRF     EEADR
L0199         MOVF     INDIR,W
              MOVWF    EEDATA
              CALL     W_picee
              INCF     FSR,F
              INCF     EEADR,F
              DECFSZ   013H,F
              GOTO     L0199

              MOVF     019H,W
              MOVWF    04EH		;speichere P2 im Flagr. 04EH ab
              MOVF     018H,W		;speichere P1 im Flagr. 04FH ab
              MOVWF    04FH
              MOVLW    05H
              MOVWF    04DH		;speichere wert 05H im Flagr. 04DH ab

;---------------------INST 40 Superencryption--------------------------------------------
; Hier werden die 5 x 8Byte Blcke entschlsselt

              CLRF     EEADR
L01A8         MOVF     EEADR,W
              MOVWF    04CH
              MOVLW    08H
              MOVWF    04BH
              MOVLW    03CH
              MOVWF    FSR
              MOVF     04CH,W
              MOVWF    EEADR
L01B0         CALL     R_picee
              MOVWF    INDIR
              INCF     FSR,F
              INCF     EEADR,F
              DECFSZ   04BH,F
              GOTO     L01B0
              MOVF     04FH,W
              MOVWF    018H
              MOVF     04EH,W
              MOVWF    019H
              CALL     get_16byte_key		;hohle Keys aus Speicher und lege sie ab 02CH ab (16Bytes)
              CALL     L032D
              MOVLW    08H
              MOVWF    04BH
              MOVLW    03CH
              MOVWF    FSR
              MOVF     04CH,W
              MOVWF    EEADR
L01C2         MOVF     INDIR,W
              MOVWF    EEDATA
              CALL     W_picee
              INCF     EEADR,F
              INCF     FSR,F
              DECFSZ   04BH,F
              GOTO     L01C2
              DECFSZ   04DH,F
              GOTO     L01A8
;------------------------------------------------------------------

;-----------Test ob Decryptet String stimmt----------------------
              MOVLW    03H		;teste ob vorletzes byte 82 ist
              SUBWF    EEADR,F
              CALL     R_picee
              XORLW    082H
              BTFSS    STATUS,Z
              GOTO     antw_901D_2
              MOVLW    08H		;teste ob Key 1 der 0C Key ist
              MOVWF    EEADR
              CALL     R_picee
              XORLW    05CH
              BTFSS    STATUS,Z
              GOTO     antw_901D_2
              MOVLW    12H		;teste ob Key 2 der 0D Key ist
              MOVWF    EEADR
              CALL     R_picee
              XORLW    05DH
              BTFSS    STATUS,Z
              GOTO     antw_901D_2
              MOVLW    1CH		;teste ob Key 3 der 0E Key ist
              MOVWF    EEADR
              CALL     R_picee
              XORLW    05EH
              BTFSS    STATUS,Z
              GOTO     antw_901D_2
 ;------------------------------------------------------------------

              MOVLW    07H
              MOVWF    EEADR
L01D3         CALL     R_picee
              INCF     EEADR,F
              MOVWF    04BH
              XORLW    082H		;teste ob Signatur kommt
              BTFSC    STATUS,Z
              GOTO     L022D		;wenn 
              MOVF     04BH,W
              XORLW    090H
              BTFSS    STATUS,Z
              GOTO     L0205
              CALL     R_picee
              ANDLW    0FH
              MOVWF    04DH
              MOVLW    08H
              MOVWF    04BH
              MOVLW    03CH
              MOVWF    FSR
              INCF     EEADR,F
L01E5         CALL     R_picee
              MOVWF    INDIR
              INCF     FSR,F
              INCF     EEADR,F
              DECFSZ   04BH,F
              GOTO     L01E5
              MOVF     EEADR,W
              MOVWF    04CH
              MOVF     04FH,W
              MOVWF    018H
              MOVF     04EH,W
              MOVWF    019H
              CALL     get_16byte_key
              CALL     L032D
              MOVF     04DH,W
              MOVWF    019H
              MOVF     04FH,W
              MOVWF    018H
              CALL     Key_adr_det

;-------schreibe neuen 8 Byte key ins EEPROM---------------
              MOVLW    08H
              MOVWF    04BH
              MOVLW    03CH
              MOVWF    FSR
L01FC         MOVF     INDIR,W
              MOVWF    EEDATA
              CALL     Rewrite
              INCF     FSR,F
              DECFSZ   04BH,F
              GOTO     L01FC
;----------------------------------------------------------
ohne_ee       MOVF     04CH,W
              MOVWF    EEADR
              GOTO     L01D3
 

L0205         ;MOVF     04BH,W
              ;XORLW    021H
              ;BTFSS    STATUS,Z
              ;GOTO     L0229
              ;MOVLW    02H
              ;MOVWF    04BH
              ;MOVLW    03CH
              ;MOVWF    FSR
L020D         ;CALL     R_picee
              ;MOVWF    INDIR
              ;INCF     FSR,F
              ;INCF     EEADR,F
              ;DECFSZ   04BH,F
              ;GOTO     L020D
              ;MOVF     EEADR,W
              ;MOVWF    04CH
              ;MOVF     04DH,W
              ;MOVWF    019H
              ;MOVF     04FH,W
              ;MOVWF    018H
;-------schreibe neues date ins EEPROM---------------------
              ;MOVLW    036H
              ;MOVWF    EEADR
              ;CALL     Key_highbyte
              ;MOVLW    02H
              ;MOVWF    04BH
              ;MOVLW    03CH
              ;MOVWF    FSR
L0220         ;MOVF     INDIR,W
              ;MOVWF    EEDATA
              ;CALL     Write_EE
              ;INCF     FSR,F
              ;DECFSZ   04BH,F
              ;GOTO     L0220
;----------------------------------------------------------
              ;MOVF     04CH,W
              ;MOVWF    EEADR
              ;GOTO     L01D3
 
L0229         SWAPF    04BH,W
              ANDLW    0FH
              ADDWF    EEADR,F
              GOTO     L01D3
 
L022D         MOVLW    097H
              CALL     Send_Byte
              MOVLW    03CH
              CALL     Send_Byte
              GOTO     String_abfr
 
;----Antworte mit 90 1D ---------------------------------------
antw_901D     CALL     L00E1
antw_901D_2   MOVLW    090H
              CALL     Send_Byte
              MOVLW    01DH
              CALL     Send_Byte
              GOTO     String_abfr
;------------------------------------------------------------------


send_eedata   CALL     send_EE_Data
              GOTO     String_ret

;----------Ermittelt die Position des Keys im EEPROM -------------- 
Key_adr_det   MOVF     019H,W		; input  019H = Keynummer 018H = Provider
              ANDLW    03H
              MOVWF    EEADR
              SWAPF    EEADR,W	; output 0CH = HighByte EEADR = LowByte
              ADDLW    030H
              BTFSC    019H,rb3
              ADDLW    020H
              MOVWF    EEADR
Key_highbyte  MOVF     018H,W
              ANDLW    0EH
              ADDLW    02H
              MOVWF    0CH
              BTFSC    018H,rb0
              BSF      EEADR,rb7
              RETURN
;------------------------------------------------------------------
 

L0247         MOVLW    01CH
              MOVWF    EEADR
              MOVLW    03CH
              GOTO     L0256
 
L024B         MOVLW    024H
              MOVWF    EEADR
              MOVLW    03CH
              GOTO     L0256
 
L024F         MOVLW    03CH
              MOVWF    EEADR
              MOVLW    01CH
              GOTO     L0256
 
L0253         MOVLW    03CH
              MOVWF    EEADR
              MOVLW    024H

L0256         MOVWF    012H
              MOVLW    08H
              MOVWF    010H
L0259         CALL     L025D
              DECFSZ   010H,F
              GOTO     L0259
 
              RETURN
 
L025D         MOVF     EEADR,W
              MOVWF    FSR
              MOVF     INDIR,W
              MOVWF    EEDATA
              MOVF     012H,W
              MOVWF    FSR
              MOVF     EEDATA,W
              MOVWF    INDIR
              INCF     EEADR,F
              INCF     012H,F
              RETURN
 
;-------hole 16 Byte Key aus EEPROM---------------------
;
;  ermittle den Aktuellen Key und lege den Primry Key doppelt
; in die adresse 02CH - 03BH ab oder wenn Sekundry mit
; genommen werden soll dann lege Prim + Sek dort ab

get_16byte_key	CALL     Key_adr_det	;ermittle aktuelle Key Adresse
			MOVLW    02CH		;defeniere den RAM bereich 02CH - 033H
			MOVWF    FSR
			CALL     get_8_Byte	;hole die 8Byte und trage diese ab 02CH ein
			CALL     Key_adr_det	;ermittle aktuelle keyadresse
			BTFSS    018H,rb4		;Teste ob Sekundry benutzt werden soll
			GOTO     L0271		
			MOVLW    08H		;wenn SEK dann hole den 2. Key aus EEPROM(LOW Adresse +8)
			ADDWF    EEADR,F
L0271			MOVLW    034H		;def. RAM Bereich 034H - 03BH
			MOVWF    FSR
			CALL     get_8_Byte	;hole die 8Byte und trage diese ab 034H ein
			RETURN
;-------------------------------------------------------------


;----hole 8 Byte Key aus dem EEPROM und lege diesen im FSR ab----
;
; Lese 8 byte aus dem EEPROM ab der Adresse die in 0CH und EEADR steht
; und speichere diese ab dem Flagregister ab
;
get_8_Byte    MOVLW    08H		
              MOVWF    010H
              MOVF     0CH,W
              MOVWF    049H
              MOVF     EEADR,W
              MOVWF    04AH
L027B         MOVF     049H,W
              MOVWF    0CH
              MOVF     04AH,W
              MOVWF    EEADR
              CALL     BSTART
              BCF      0CH,rb0
              CALL     CONTROL_BYTE
              MOVF     EEADR,W
              CALL     TX
              CALL     BSTART
              BSF      0CH,rb0
              CALL     CONTROL_BYTE
              CALL     RX
              MOVF     0EH,W
              MOVWF    INDIR
              INCF     FSR,F
              CALL     BSTOP
              INCF     04AH,F
              DECFSZ   010H,F
              GOTO     L027B
              RETURN
;--------------------------------------------
 


;######################################################
;	Sende Bytes vom EEPROM zum Reciver
;	0CH = High Byte der EEPROM Adresse
;	01AH= Lnge des Strings
;	EEADR=Low byte der EEPROM Adresse 
;######################################################
send_EE_Data    MOVF     01AH,W
              MOVWF    010H
              MOVF     0CH,W
              MOVWF    049H
              MOVF     EEADR,W
              MOVWF    04AH
L0296         MOVF     049H,W
              MOVWF    0CH
              MOVF     04AH,W
              MOVWF    EEADR
              CALL     BSTART
              BCF      0CH,rb0
              CALL     CONTROL_BYTE
              MOVF     EEADR,W
              CALL     TX
              CALL     BSTART
              BSF      0CH,rb0
              CALL     CONTROL_BYTE
              CALL     RX
              MOVF     0EH,W
              CALL     Send_Byte
              MOVLW    05DH
              CALL     Schleife_B
              CALL     BSTOP
              INCF     04AH,F
              DECFSZ   010H,F
              GOTO     L0296
              RETURN
 
;######################################################
;	EEPROM Read ROUTINE 1
;######################################################
Read_EE1      CALL     BSTART
              BCF      0CH,rb0
              CALL     CONTROL_BYTE
              MOVF     EEADR,W
              CALL     TX
              CALL     BSTART
              BSF      0CH,rb0
              CALL     CONTROL_BYTE
              CALL     RX
              CALL     BSTOP
              CALL     L02D6
              MOVF     0EH,W
              RETURN
 
Rewrite       MOVF     EEADR,W
              MOVWF    018H
              MOVF     0CH,W
              MOVWF    017H
              CALL     Read_EE1
              MOVF     018H,W
              MOVWF    EEADR
              MOVF     017H,W
              MOVWF    0CH
              BCF      STATUS,CY
              MOVF     0EH,W
              XORWF    EEDATA,W
              BTFSC    STATUS,Z
              GOTO     L02D6
 
;######################################################
;	EEPROM WRITE ROUTINE
;######################################################
Write_EE	  CALL     BSTART
              BCF      0CH,rb0
              CALL     CONTROL_BYTE
              MOVF     EEADR,W
              CALL     TX
              MOVF     EEDATA,W
              CALL     TX
              CALL     BSTOP
              CALL     L02D6
              MOVLW    0CH
              MOVWF    019H
L02D1         MOVLW    0FFH
              CALL     Schleife_B
              DECFSZ   019H,F
              GOTO     L02D1
              RETURN
 
L02D6         BCF      STATUS,CY
              MOVLW    01H
              ADDWF    EEADR,F
              BTFSS    STATUS,CY
              RETURN
              RRF      0CH,F
              INCF     0CH,F
              RLF      0CH,F
              RETURN
 
;**********************************************
;	GENERATE CONTROL BYTE
;**********************************************
;MASK OUT UPPER NIBBLE
;COMPLETE BYTE 1010AAAD
;A=ADRESS D=DIRECTION
;SEND CONTROL BYTE

CONTROL_BYTE  MOVF     0CH,W
              ANDLW    0FH
              IORLW    0A0H

;**********************************************
;	TRANSMIT DATA SUBROUTINE
;**********************************************
TX         MOVWF    0EH
           MOVLW    0CFH
           TRIS     PORTB
           CALL     TX4
           CALL     TX4
           GOTO     BITIN
 
TX4        CALL     TXLP
           CALL     TXLP
           CALL     TXLP
TXLP       RLF      0EH,F
           GOTO     BITOUT_R
 
;**********************************************
;	RECEIVE DATA SUBROUTINE
;**********************************************
RX         MOVLW    0DFH
           TRIS     PORTB
           CALL     RX4
           CALL     RX4
           BSF      STATUS,CY
           GOTO     BITOUT
 
RX4        CALL     RXLP
           CALL     RXLP
           CALL     RXLP
RXLP       CALL     BITIN_R
           RLF      0EH,F
           RETURN
 
;*********************************************
;	START BIT SUBROUTINE
;*********************************************
BSTART     BSF      PORTB,rb4
           MOVLW    0CFH
           TRIS     PORTB
           BSF      PORTB,rb5
           NOP
           BCF      PORTB,rb4
           GOTO     BC_END
 
;**********************************************
;	STOP BIT SUBROUTINE
;**********************************************
BSTOP         BCF      PORTB,rb4
              MOVLW    0CFH
              TRIS     PORTB
              NOP
              BSF      PORTB,rb5
              NOP
              BSF      PORTB,rb4
B_END         NOP
BC_END         BCF      PORTB,rb5
              RETURN
 
;**********************************************
;	BITOUT ROUTINE , SEND BIT WHEN CARRY SET
;**********************************************
BITOUT        MOVLW    0CFH
              TRIS     PORTB
BITOUT_R      BTFSS    STATUS,CY
              BCF      PORTB,rb4
              BTFSC    STATUS,CY
              BSF      PORTB,rb4
              BSF      PORTB,rb5
              GOTO     B_END
 
;**********************************************
;	BITIN ROUTINE
;**********************************************
BITIN         MOVLW    0DFH
              TRIS     PORTB
BITIN_R       BSF      PORTB,rb5
              NOP
              BSF      STATUS,CY
              BTFSS    PORTB,rb4
              BCF      STATUS,CY
              GOTO     BC_END
 

;-----Lese Byte aus den Hash Tabellen-------------------
read_hash1    MOVWF    EEADR
              MOVLW    0CH
              GOTO     L0325
read_hash2    MOVWF    EEADR
              MOVLW    0EH
L0325         MOVWF    0CH
              CALL     Read_EE1
              RETURN
;-------------------------------------------------------
 

L0328         MOVF     015H,W
L0329         ANDLW    0FH
              ADDLW    02CH
              MOVWF    FSR
              RETURN
 
;---- ALGO  --------------------------------------------
L032D         MOVLW    00H
              MOVWF    017H
L032F         MOVF     017H,W
              ANDLW    0FH
              MOVWF    015H
              MOVF     017H,W
              ANDLW    03CH
              MOVWF    014H
              BCF      STATUS,CY
              RRF      014H,F
              RRF      014H,F
              CALL     L03C0
              INCF     017H,F
              BTFSS    017H,rb6
              GOTO     L032F
              MOVLW    0FH
              MOVWF    015H
              MOVWF    014H
L033F         MOVF     040H,W
              MOVWF    017H
              MOVF     041H,W
              MOVWF    018H
              MOVF     042H,W
              MOVWF    019H
              MOVF     043H,W
              MOVWF    01AH
              CALL     L0328
              MOVF     INDIR,W
              XORWF    01AH,W
              MOVWF    01AH
              CALL     L03C0
              DECF     015H,F
              CALL     L0328
              MOVF     INDIR,W
              XORWF    019H,W
              MOVWF    019H
              CALL     L03C0
              DECF     015H,F
              CALL     L0328
              MOVF     INDIR,W
              XORWF    018H,W
              MOVWF    018H
              CALL     L03C0
              DECF     015H,F
              CALL     L0328
              MOVF     INDIR,W
              XORWF    017H,W
              MOVWF    017H
              CALL     L03C0
              DECF     015H,F
              MOVF     015H,W
              ANDLW    0FH
              MOVWF    015H
              MOVF     017H,W
              CALL     read_hash1
              MOVWF    017H
              MOVF     018H,W
              CALL     read_hash1
              MOVWF    018H
              MOVF     019H,W
              CALL     read_hash1
              MOVWF    019H
              MOVF     01AH,W
              CALL     read_hash1
              MOVWF    01AH
              XORWF    017H,W
              MOVWF    017H
              SWAPF    01AH,W
              ADDWF    019H,W
              CALL     read_hash2
              MOVWF    019H
              XORWF    01AH,W
              MOVWF    01AH
              SWAPF    019H,W
              ADDWF    018H,W
              CALL     read_hash2
              MOVWF    018H
              XORWF    019H,W
              MOVWF    019H
              SWAPF    018H,W
              ADDWF    017H,W
              CALL     read_hash2
              MOVWF    017H
              XORWF    018H,W
              MOVWF    018H
              SWAPF    017H,W
              ADDWF    01AH,W
              CALL     read_hash1
              MOVWF    01AH
              XORWF    017H,W
              MOVWF    017H
              SWAPF    01AH,W
              ADDWF    019H,W
              CALL     read_hash1
              MOVWF    019H
              XORWF    01AH,W
              MOVWF    01AH
              SWAPF    019H,W
              ADDWF    018H,W
              CALL     read_hash1
              MOVWF    018H
              XORWF    019H,W
              MOVWF    019H
              MOVF     018H,W
              XORWF    017H,W
              MOVWF    018H
              MOVF     018H,W
              CALL     read_hash2
              XORWF    03CH,F
              MOVF     01AH,W
              CALL     read_hash2
              XORWF    03DH,F
              MOVF     017H,W
              CALL     read_hash2
              XORWF    03EH,F
              MOVF     019H,W
              CALL     read_hash2
              XORWF    03FH,F
              DECF     014H,F
              BTFSS    014H,rb7
              GOTO     change_key
              RETURN
 
;----tausche  040H-043H <--> 03CH-03FH-------------------
change_key    MOVF     040H,W		;tausche flagreg. 040H <-> 03CH
              MOVWF    013H
              MOVF     03CH,W
              MOVWF    040H
              MOVF     013H,W
              MOVWF    03CH
              MOVF     041H,W		;tausche flagreg. 041H <-> 03DH
              MOVWF    013H
              MOVF     03DH,W
              MOVWF    041H
              MOVF     013H,W
              MOVWF    03DH
              MOVF     042H,W		;tausche flagreg. 042H <-> 03EH
              MOVWF    013H
              MOVF     03EH,W
              MOVWF    042H
              MOVF     013H,W
              MOVWF    03EH
              MOVF     043H,W		;tausche flagreg. 043H <-> 03FH
              MOVWF    013H
              MOVF     03FH,W
              MOVWF    043H
              MOVF     013H,W
              MOVWF    03FH
              GOTO     L033F
;-------------------------------------------------------



L03C0         MOVF     015H,W
              ADDLW    01H
              ANDLW    0FH
              MOVWF    01BH
              CALL     L0329
              MOVF     INDIR,W
              XORWF    014H,W
              MOVWF    013H
              MOVLW    02H
              SUBWF    01BH,W
              ANDLW    0FH
              CALL     L0329
              MOVF     INDIR,W
              XORWF    013H,W
              CALL     read_hash1
              MOVWF    013H
              CALL     L0328
              MOVF     INDIR,W
              XORWF    013H,W
              MOVWF    INDIR
              RETURN
 
W_picee       BSF      STATUS,RP0
              BSF      EEDATA,rb2
              MOVLW    055H
              MOVWF    EEADR
              MOVLW    0AAH
              MOVWF    EEADR
              BSF      EEDATA,rb1
L03DC         BTFSC    EEDATA,rb1
              GOTO     L03DC
              BCF      STATUS,RP0
              RETURN
 
R_picee       BSF      STATUS,RP0
              BSF      EEDATA,rb0
              BCF      STATUS,RP0
              MOVF     EEDATA,W
              RETURN
 
              ORG 2007H
              DATA 3FF9H
 
              END
