      TITLE   'Mastercrd.ASM'
       LIST    P=16F84
 
IO_PIN EQU 007H ;SET INPUT / OUTPUT PIN
;
IO_MASK = 0FFH & ~(1 << IO_PIN)
 
 
CY      EQU     0       ; Carry/borrow bit
DC      EQU     1       ; Digit carry
Z       EQU     2       ; Zero flag
PD      EQU     3       ; Power down
T0      EQU     4       ; Time-out bit
RP0     EQU     5       ; Register page select bits
RP1     EQU     6       ; Not used in 16C84
RP2     EQU     7       ; Not used in 16C84
INDIR   EQU     00H     ; Indirect pointer
RTCC    EQU     01H     ; Real time clock / counter
PCL     EQU     02H     ; Program counter low byte
STATUS  EQU     03H     ; Status register
FSR     EQU     04H     ; Indirect pointer
PORTA   EQU     05H     ; PORT A
PORTB   EQU     06H     ; PORT B
PORTC   EQU     07H     ; PORT C
EEDATA  EQU     08H     ; Eeprom data
EEADR   EQU     09H     ; Eeprom address
PCLATH  EQU     0AH     ; Program counter high byte
INTCON  EQU     0BH     ; Interrupt control
TRISA   EQU     085H    ; Data direction port A
TRISB   EQU     086H    ; Data direction port B
EECON1  EQU     088H    ; Eeprom control
W       EQU     0       ; W reg. as destination
F       EQU     1       ; F file as destination
 
 
SCLK    EQU     5      ;SERIAL EEPROM CLOCK LINE
SDATA   EQU     4      ;SERIAL EEPROM DATA LINE
 
;---------------------------------------------
; Variablen Deffinition
;---------------------------------------------
 
rb0     equ     00H     ; i/o card 0
rb1     equ     01H     ; i/o card 1
rb2     equ     02H     ; switch card 1
rb3     equ     03H     ; switch card 1
rb4     equ     04H     ; i/o card 2
rb5     equ     05H     ; usato dal soft originale (mantenuto per compatibilita')
rb6     equ     06H     ; switch card 2
rb7     equ     07H     ; i/o CAM
 
             ORG 0000H
 
              GOTO     L0081
 
              NOP
              NOP
              NOP
              RETFIE
 
L0005         CLRF     0DH
              BCF      STATUS,CY
              MOVLW    08H
              MOVWF    0FH
L0009         RLF      EEDATA,F
              BTFSS    STATUS,CY
              GOTO     L000D
 
              INCF     0DH,F
L000D         DECFSZ   0FH,F
              GOTO     L0009
 
              RLF      EEDATA,F
              RETURN
 
L0011         MOVF     017H,W
L0012         MOVWF    EEDATA
              CALL     L0005
              MOVLW    07FH
              TRIS     PORTB
              BCF      PORTB,rb7
              NOP
              NOP
              MOVLW    09H
              MOVWF    0FH
              CALL     L004C
              RRF      0DH,F
L001D         RRF      EEDATA,F
              BTFSC    STATUS,CY
              GOTO     L0023
 
              NOP
              BCF      PORTB,rb7
              GOTO     L0026
 
L0023         BSF      PORTB,rb7
              NOP
              NOP
L0026         CALL     L004C
              DECFSZ   0FH,F
              GOTO     L001D
 
              NOP
              NOP
              NOP
              NOP
              NOP
              BSF      PORTB,rb7
              MOVLW    0FFH
              TRIS     PORTB
              MOVLW    059H
              CALL     L004D
              RETURN
 
L0034         MOVLW    05DH
              CALL     L004D
              RETURN
 
L0037         BTFSC    PORTB,rb7
              GOTO     L0037
 
              MOVLW    02AH
              CALL     L004D
              MOVLW    08H
              MOVWF    0FH
L003D         RRF      EEDATA,F
              BTFSS    PORTB,rb7
              GOTO     L0041
 
              GOTO     L0043
 
L0041         BCF      EEDATA,rb7
              GOTO     L0045
 
L0043         BSF      EEDATA,rb7
              NOP
L0045         CALL     L004C
              DECFSZ   0FH,F
              GOTO     L003D
 
              MOVLW    051H
              CALL     L004D
              MOVF     EEDATA,W
              RETURN
 
L004C         MOVLW    01AH
L004D         MOVWF    011H
L004E         DECFSZ   011H,F
              GOTO     L004E
 
              RETURN
 
L0051         MOVLW    02AH
              MOVWF    0FH
L0053         CALL     L004C
              DECFSZ   0FH,F
              GOTO     L0053
 
              RETURN
 
L0057         CALL     L0037
              CALL     L0037
              MOVWF    0CH
              RLF      0CH,F
              CALL     L0037
              MOVWF    EEADR
              CALL     L0037
              MOVWF    01AH
              MOVWF    01BH
              MOVLW    0C2H
              CALL     L0012
              MOVLW    01CH
              MOVWF    FSR
L0064         CALL     L0037
              MOVWF    INDIR
              INCF     FSR,F
              DECFSZ   01AH,F
              GOTO     L0064
 
              MOVLW    01CH
              MOVWF    FSR
L006B         MOVF     INDIR,W
              MOVWF    EEDATA
              CALL     L029B
              INCF     FSR,F
              DECFSZ   01BH,F
              GOTO     L006B
 
              GOTO     L0092
 
L0072         CALL     L0037
              CALL     L0037
              MOVWF    0CH
              RLF      0CH,F
              CALL     L0037
              MOVWF    EEADR
              CALL     L0037
              MOVWF    01AH
              MOVLW    0C3H
              CALL     L0012
L007C         CALL     L028E
              CALL     L0012
              DECFSZ   01AH,F
              GOTO     L007C
 
              GOTO     L0092
 
;*************************

L0081         CLRF     FSR
              BSF      STATUS,RP0
              BCF      RTCC,rb7
              BCF      STATUS,RP0
              MOVLW    0FFH
              TRIS     PORTA
              MOVLW    0FFH
              TRIS     PORTB
              MOVWF    PORTA
              MOVWF    PORTB
              CALL     L0051
              CLRF     0CH
              MOVLW    00H
              MOVWF    EEADR
              MOVLW    0EH
              MOVWF    01AH
              GOTO     L021B
 
L0092         MOVLW    090H
              CALL     L0012
              MOVLW    00H
              CALL     L0012
L0096         CALL     L0037
              MOVWF    016H
              XORLW    0C2H
              BTFSC    STATUS,Z
              GOTO     L0057
 
              MOVF     016H,W
              XORLW    0C3H
              BTFSC    STATUS,Z
              GOTO     L0072
 
              MOVF     016H,W
              XORLW    0C1H
              BTFSS    STATUS,Z
              GOTO     L0096
 
              CALL     L0037
              MOVWF    017H
              CALL     L0037
              MOVWF    018H
              CALL     L0037
              MOVWF    019H
              CALL     L0037
              MOVWF    01AH
              CALL     L004C

              MOVF     017H,W
              XORLW    0AH
              BTFSC    STATUS,Z
              GOTO     L00DD
 
              MOVF     017H,W
              XORLW    0EH
              BTFSC    STATUS,Z
              GOTO     L00E2
 
              MOVF     017H,W
              XORLW    012H
              BTFSC    STATUS,Z
              GOTO     L00E7
 
              MOVF     017H,W
              XORLW    016H
              BTFSC    STATUS,Z
              GOTO     L00EC
 
              MOVF     017H,W
              XORLW    030H
              BTFSC    STATUS,Z
              GOTO     L00F1
 
              MOVF     017H,W
              XORLW    032H
              BTFSC    STATUS,Z
              GOTO     L00F4
 
              MOVF     017H,W
              XORLW    034H
              BTFSC    STATUS,Z
              GOTO     L0133
 
              MOVF     017H,W
              XORLW    03AH
              BTFSC    STATUS,Z
              GOTO     L013B
 
              MOVF     017H,W
              XORLW    03CH
              BTFSC    STATUS,Z
              GOTO     L0144
 
              MOVF     017H,W
              XORLW    040H
              BTFSC    STATUS,Z
              GOTO     L015F
 
              MOVLW    06BH
              CALL     L0012
              MOVLW    00H
              CALL     L0012
              GOTO     L0096
 
L00D9         CALL     L0037
              DECFSZ   01AH,F
              GOTO     L00D9
 
              RETURN
 
L00DD         CALL     L0011
              CLRF     0CH
              MOVLW    030H
              MOVWF    EEADR
              GOTO     L021B
 
L00E2         CALL     L0011
              CLRF     0CH
              MOVLW    020H
              MOVWF    EEADR
              GOTO     L021B
 
L00E7         CALL     L0011
              MOVLW    020H
              MOVWF    EEADR
              CALL     L0223
              GOTO     L021B
 
L00EC         CALL     L0011
              CLRF     0CH
              MOVLW    040H
              MOVWF    EEADR
              GOTO     L021B
 
L00F1         CALL     L0011
              CALL     L00D9
              GOTO     L0092
 
L00F4         CALL     L0011
              MOVF     01AH,W
              XORLW    0DH
              BTFSC    STATUS,Z
              GOTO     L0105
 
              MOVF     044H,W
              XORLW    03H
              BTFSC    STATUS,Z
              GOTO     L0109
 
              MOVF     044H,W
              XORLW    04H
              BTFSC    STATUS,Z
              GOTO     L012F
 
              MOVLW    00H
              MOVWF    EEADR
              CALL     L0223
              GOTO     L021B
 
L0105         CLRF     0CH
              MOVLW    060H
              MOVWF    EEADR
              GOTO     L021B
 
L0109         MOVF     045H,W
              XORLW    00H
              BTFSC    STATUS,Z
              GOTO     L011F
 
              MOVLW    0B1H
              CALL     L0012
              DECF     01AH,F
              MOVLW    01H
              CALL     L0012
              DECF     01AH,F
              MOVF     045H,W
              MOVWF    047H
              CALL     L0012
              DECF     01AH,F
              MOVF     046H,W
              MOVWF    048H
              CALL     L0012
              DECF     01AH,F
              CLRF     0CH
              MOVLW    084H
              MOVWF    EEADR
              GOTO     L021B
 
L011F         MOVLW    0B1H
              CALL     L0012
              DECF     01AH,F
              MOVLW    00H
              CALL     L0012
              DECF     01AH,F
              MOVF     047H,W
              CALL     L0012
              DECF     01AH,F
              MOVF     048H,W
              CALL     L0012
              DECF     01AH,F
              CLRF     0CH
              MOVLW    0A4H
              MOVWF    EEADR
              GOTO     L021B
 
L012F         CLRF     0CH
              MOVLW    0C0H
              MOVWF    EEADR
              GOTO     L021B
 
L0133         CALL     L0011
              CALL     L0037
              MOVWF    044H
              CALL     L0037
              MOVWF    045H
              CALL     L0037
              MOVWF    046H
              GOTO     L0092
 
L013B         CALL     L0011
              MOVLW    01CH
              MOVWF    FSR
L013E         MOVF     INDIR,W
              CALL     L0012
              INCF     FSR,F
              DECFSZ   01AH,F
              GOTO     L013E
 
              GOTO     L0092
 
L0144         CALL     L0011
L0145         CALL     L0037
              DECF     01AH,F
              XORLW    0D1H
              BTFSS    STATUS,Z
              GOTO     L0145
 
              CALL     L0154
              CALL     L00D9
              CALL     L024B
              CALL     L022A
              CALL     L0310
              CALL     L0232
              CALL     L022E
              CALL     L0310
              CALL     L0236
              GOTO     L0092
 
L0154         MOVLW    010H
              MOVWF    013H
              MOVLW    01CH
              MOVWF    FSR
L0158         CALL     L0037
              DECF     01AH,F
              MOVWF    INDIR
              INCF     FSR,F
              DECFSZ   013H,F
              GOTO     L0158
 
              RETURN
 
L015F         CALL     L0011
              MOVLW    081H
              XORWF    019H,W
              BTFSS    STATUS,Z
              GOTO     L0215
 
              MOVLW    04EH
              XORWF    01AH,W
              BTFSS    STATUS,Z
              GOTO     L0215
 
              MOVLW    020H
              MOVWF    04BH
L016A         CALL     L0037
              DECF     01AH,F
              DECFSZ   04BH,F
              GOTO     L016A
 
              MOVF     01AH,W
              MOVWF    013H
              MOVLW    01CH
              MOVWF    FSR
L0172         CALL     L0037
              MOVWF    INDIR
              INCF     FSR,F
              DECFSZ   013H,F
              GOTO     L0172
 
              MOVF     01AH,W
              MOVWF    013H
              MOVLW    01CH
              MOVWF    FSR
              CLRF     EEADR
L017C         MOVF     INDIR,W
              MOVWF    EEDATA
              CALL     L03B8
              INCF     FSR,F
              INCF     EEADR,F
              DECFSZ   013H,F
              GOTO     L017C
 
              MOVLW    0FH
              IORWF     019H,W
              MOVWF    04EH
              MOVF     018H,W
              MOVWF    04FH
              MOVLW    05H
              MOVWF    04DH
              CLRF     EEADR
L018B         MOVF     EEADR,W
              MOVWF    04CH
              MOVLW    08H
              MOVWF    04BH
              MOVLW    03CH
              MOVWF    FSR
              MOVF     04CH,W
              MOVWF    EEADR
L0193         CALL     L03C3
              MOVWF    INDIR
              INCF     FSR,F
              INCF     EEADR,F
              DECFSZ   04BH,F
              GOTO     L0193
 
              MOVF     04FH,W
              MOVWF    018H
              MOVF     04EH,W
              MOVWF    019H
              CALL     L024B
              CALL     L0310
              MOVLW    08H
              MOVWF    04BH
              MOVLW    03CH
              MOVWF    FSR
              MOVF     04CH,W
              MOVWF    EEADR
L01A5         MOVF     INDIR,W
              MOVWF    EEDATA
              CALL     L03B8
              INCF     EEADR,F
              INCF     FSR,F
              DECFSZ   04BH,F
              GOTO     L01A5
 
              DECFSZ   04DH,F
              GOTO     L018B
 
              MOVLW    03H
              SUBWF    EEADR,F
              CALL     L03C3
              XORLW    082H
              BTFSS    STATUS,Z
              GOTO     L0216
 
              MOVLW    01H
              MOVWF    EEADR
L01B6         CALL     L03C3
              INCF     EEADR,F
              MOVWF    04BH
              XORLW    082H
              BTFSC    STATUS,Z
              GOTO     L0210
 
              MOVF     04BH,W
              XORLW    090H
              BTFSS    STATUS,Z
              GOTO     L01E8
 
              CALL     L03C3
              ANDLW    0FH
              MOVWF    04DH
              MOVLW    08H
              MOVWF    04BH
              MOVLW    03CH
              MOVWF    FSR
              INCF     EEADR,F
L01C8         CALL     L03C3
              MOVWF    INDIR
              INCF     FSR,F
              INCF     EEADR,F
              DECFSZ   04BH,F
              GOTO     L01C8
 
              MOVF     EEADR,W
              MOVWF    04CH
              MOVF     04FH,W
              MOVWF    018H
              MOVF     04EH,W
              MOVWF    019H
              CALL     L024B
              CALL     L0310
              MOVF     04DH,W
              MOVWF    019H
              MOVF     04FH,W
              MOVWF    018H
              CALL     L021D
              MOVLW    08H
              MOVWF    04BH
              MOVLW    03CH
              MOVWF    FSR
L01DF         MOVF     INDIR,W
              MOVWF    EEDATA
              CALL     L02A9
              INCF     FSR,F
              DECFSZ   04BH,F
              GOTO     L01DF
 
              MOVF     04CH,W
              MOVWF    EEADR
              GOTO     L01B6
 
L01E8         MOVF     04BH,W
              XORLW    021H
              BTFSS    STATUS,Z
              GOTO     L020C
 
              MOVLW    02H
              MOVWF    04BH
              MOVLW    03CH
              MOVWF    FSR
L01F0         CALL     L03C3
              MOVWF    INDIR
              INCF     FSR,F
              INCF     EEADR,F
              DECFSZ   04BH,F
              GOTO     L01F0
 
              MOVF     EEADR,W
              MOVWF    04CH
              MOVF     04DH,W
              MOVWF    019H
              MOVF     04FH,W
              MOVWF    018H
              MOVLW    036H
              MOVWF    EEADR
              CALL     L0223
              MOVLW    02H
              MOVWF    04BH
              MOVLW    03CH
              MOVWF    FSR
L0203         MOVF     INDIR,W
              MOVWF    EEDATA
              CALL     L02A9
              INCF     FSR,F
              DECFSZ   04BH,F
              GOTO     L0203
 
              MOVF     04CH,W
              MOVWF    EEADR
              GOTO     L01B6
 
L020C         SWAPF    04BH,W
              ANDLW    0FH
              ADDWF    EEADR,F
              GOTO     L01B6
 
L0210         MOVLW    097H
              CALL     L0012
              MOVLW    0DFH
              CALL     L0012
              GOTO     L0096
 
L0215         CALL     L00D9
L0216         MOVLW    090H
              CALL     L0012
              MOVLW    02H
              CALL     L0012
              GOTO     L0096
 
L021B         CALL     L0273
              GOTO     L0092
 
L021D         MOVF     019H,W
              ANDLW    03H
              MOVWF    EEADR
              SWAPF    EEADR,W
              ADDLW    040H
              MOVWF    EEADR
L0223         MOVF     018H,W
              ANDLW    06H
              IORLW    08H
              MOVWF    0CH
              BTFSC    018H,rb0
              BSF      EEADR,rb7
              RETURN
 
L022A         MOVLW    01CH
              MOVWF    EEADR
              MOVLW    03CH
              GOTO     L0239
 
L022E         MOVLW    024H
              MOVWF    EEADR
              MOVLW    03CH
              GOTO     L0239
 
L0232         MOVLW    03CH
              MOVWF    EEADR
              MOVLW    01CH
              GOTO     L0239
 
L0236         MOVLW    03CH
              MOVWF    EEADR
              MOVLW    024H

L0239         MOVWF    012H
              MOVLW    08H
              MOVWF    010H
L023C         CALL     L0240
              DECFSZ   010H,F
              GOTO     L023C
              RETURN
 
L0240         MOVF     EEADR,W
              MOVWF    FSR
              MOVF     INDIR,W
              MOVWF    EEDATA
              MOVF     012H,W
              MOVWF    FSR
              MOVF     EEDATA,W
              MOVWF    INDIR
              INCF     EEADR,F
              INCF     012H,F
              RETURN
 
L024B         CALL     L021D
              MOVLW    02CH
              MOVWF    FSR
              CALL     L0258
              CALL     L021D
              BTFSS    018H,rb4
              GOTO     L0254
 
              MOVLW    08H
              ADDWF    EEADR,F
L0254         MOVLW    034H
              MOVWF    FSR
              CALL     L0258
              RETURN
 
L0258		MOVLW    08H
              MOVWF    010H
              MOVF     0CH,W
              MOVWF    049H
              MOVF     EEADR,W
              MOVWF    04AH
L025E         MOVF     049H,W
              MOVWF    0CH
              MOVF     04AH,W
              MOVWF    EEADR
              CALL     BSTART
              BCF      0CH,rb0
              CALL     CONTROL_BYTE
              MOVF     EEADR,W
              CALL     TX
              CALL     BSTART
              BSF      0CH,rb0
              CALL     CONTROL_BYTE
              CALL     RX
              MOVF     0EH,W
              MOVWF    INDIR
              INCF     FSR,F
              CALL     BSTOP
              INCF     04AH,F
              DECFSZ   010H,F
              GOTO     L025E
              RETURN
 
L0273         MOVF     01AH,W
              MOVWF    010H
              MOVF     0CH,W
              MOVWF    049H
              MOVF     EEADR,W
              MOVWF    04AH
L0279         MOVF     049H,W
              MOVWF    0CH
              MOVF     04AH,W
              MOVWF    EEADR
              CALL     BSTART
              BCF      0CH,rb0
              CALL     CONTROL_BYTE
              MOVF     EEADR,W
              CALL     TX
              CALL     BSTART
              BSF      0CH,rb0
              CALL     CONTROL_BYTE
              CALL     RX
              MOVF     0EH,W
              CALL     L0012
              CALL     L0034
              CALL     BSTOP
              INCF     04AH,F
              DECFSZ   010H,F
              GOTO     L0279
              RETURN
 
L028E         CALL     BSTART
              BCF      0CH,rb0
              CALL     CONTROL_BYTE
              MOVF     EEADR,W
              CALL     TX
              CALL     BSTART
              BSF      0CH,rb0
              CALL     CONTROL_BYTE
              CALL     RX
              CALL     BSTOP
              CALL     L02B9
              MOVF     0EH,W
              RETURN
 
L029B         MOVF     EEADR,W
              MOVWF    018H
              MOVF     0CH,W
              MOVWF    017H
              CALL     L028E
              MOVF     018H,W
              MOVWF    EEADR
              MOVF     017H,W
              MOVWF    0CH
              BCF      STATUS,CY
              MOVF     0EH,W
              XORWF    EEDATA,W
              BTFSC    STATUS,Z
              GOTO     L02B9
 
;######################################################
;	EEPROM WRITE ROUTINE
;######################################################

L02A9	MOVF	0CH, W
	ANDLW	08H
	BTFSC	STATUS,Z
	RETURN
	MOVF	EEADR,W
	ANDLW	078H
	XORLW	040H
	BTFSC	STATUS,Z
	GOTO goon

	MOVF	EEADR,W
	ANDLW	078H
	XORLW	050H
	BTFSC	STATUS,Z
	GOTO goon

	MOVF	EEADR,W
	ANDLW	078H
	XORLW	060H
	BTFSS	STATUS,Z
	RETURN

goon	CALL     BSTART
        BCF      0CH,0
	BSF	0CH,3
        CALL     CONTROL_BYTE
              MOVF     EEADR,W
              CALL     TX
              MOVF     EEDATA,W
              CALL     TX
              CALL     BSTOP
              CALL     L02B9
              MOVLW    0CH
              MOVWF    019H
L02B4         MOVLW    0FFH
              CALL     L004D
              DECFSZ   019H,F
              GOTO     L02B4
              RETURN
 
L02B9         ;BCF      STATUS,CY
              MOVLW    01H
              ADDWF    EEADR,F
              ;BTFSS    STATUS,CY
              RETURN
 
              RRF      0CH,F
              INCF     0CH,F
              RLF      0CH,F
              RETURN
 
;**********************************************
;	GENERATE CONTROL BYTE
;**********************************************
CONTROL_BYTE         MOVF     0CH,W
              ANDLW    0FH
              IORLW    0A0H


;**********************************************
;	TRANSMIT DATA SUBROUTINE
;**********************************************
TX         MOVWF    0EH
              MOVLW    0CFH
              TRIS     PORTB
              CALL     TX4
              CALL     TX4
              GOTO     BITIN
 
TX4         CALL     TXLP
              CALL     TXLP
              CALL     TXLP
TXLP         RLF      0EH,F
              GOTO     BITOUT_R
 
              MOVLW    0DFH
              TRIS     PORTB
              CALL     RX4
              CALL     RX4
              BCF      STATUS,CY
              GOTO     BITOUT
 
;**********************************************
;	RECEIVE DATA SUBROUTINE
;**********************************************
RX         MOVLW    0DFH
              TRIS     PORTB
              CALL     RX4
              CALL     RX4
              BSF      STATUS,CY
              GOTO     BITOUT
 
RX4         CALL     RXLP
              CALL     RXLP
              CALL     RXLP
RXLP         CALL     BITIN_R
              RLF      0EH,F
              RETURN
 
;*********************************************
;	START BIT SUBROUTINE
;*********************************************
BSTART         BSF      PORTB,rb4
              MOVLW    0CFH
              TRIS     PORTB
              BSF      PORTB,rb5
              NOP
              BCF      PORTB,rb4
              GOTO     BC_END
 
;**********************************************
;	STOP BIT SUBROUTINE
;**********************************************
BSTOP         BCF      PORTB,rb4
              MOVLW    0CFH
              TRIS     PORTB
              NOP
              BSF      PORTB,rb5
              NOP
              BSF      PORTB,rb4
B_END         NOP
BC_END         BCF      PORTB,rb5
              RETURN
 
;**********************************************
;	BITOUT ROUTINE , SEND BIT WHEN CARRY SET
;**********************************************
BITOUT         MOVLW    0CFH
              TRIS     PORTB
BITOUT_R      BTFSS    STATUS,CY
              BCF      PORTB,rb4
              BTFSC    STATUS,CY
              BSF      PORTB,rb4
              BSF      PORTB,rb5
              GOTO     B_END
 
;**********************************************
;	BITIN ROUTINE
;**********************************************
BITIN         MOVLW    0DFH
              TRIS     PORTB
BITIN_R         BSF      PORTB,rb5
              NOP
              BSF      STATUS,CY
              BTFSS    PORTB,rb4
              BCF      STATUS,CY
              GOTO     BC_END
 
;######################################################
;	EEPROM READ ROUTINE
;######################################################
;		Used reg: EEADR, EEDATA,W
;		IN  : W= READ ADRESS
;		OUT : W= BYTE
L0303         MOVWF    EEADR
              MOVLW    04H
              GOTO     L0308
 
L0306         MOVWF    EEADR
              MOVLW    06H
L0308         MOVWF    0CH
              CALL     L028E
              RETURN
 
L030B         MOVF     015H,W
L030C         ANDLW    0FH
              ADDLW    02CH
              MOVWF    FSR
              RETURN
 
L0310         MOVLW    00H
              MOVWF    017H
L0312         MOVF     017H,W
              ANDLW    0FH
              MOVWF    015H
              MOVF     017H,W
              ANDLW    03CH
              MOVWF    014H
              BCF      STATUS,CY
              RRF      014H,F
              RRF      014H,F
              CALL     L03A3
              INCF     017H,F
              BTFSS    017H,rb6
              GOTO     L0312
 
              MOVLW    0FH
              MOVWF    015H
              MOVWF    014H
L0322         MOVF     040H,W
              MOVWF    017H
              MOVF     041H,W
              MOVWF    018H
              MOVF     042H,W
              MOVWF    019H
              MOVF     043H,W
              MOVWF    01AH
              CALL     L030B
              MOVF     INDIR,W
              XORWF    01AH,W
              MOVWF    01AH
              CALL     L03A3
              DECF     015H,F
              CALL     L030B
              MOVF     INDIR,W
              XORWF    019H,W
              MOVWF    019H
              CALL     L03A3
              DECF     015H,F
              CALL     L030B
              MOVF     INDIR,W
              XORWF    018H,W
              MOVWF    018H
              CALL     L03A3
              DECF     015H,F
              CALL     L030B
              MOVF     INDIR,W
              XORWF    017H,W
              MOVWF    017H
              CALL     L03A3
              DECF     015H,F
              MOVF     015H,W
              ANDLW    0FH
              MOVWF    015H
              MOVF     017H,W
              CALL     L0303
              MOVWF    017H
              MOVF     018H,W
              CALL     L0303
              MOVWF    018H
              MOVF     019H,W
              CALL     L0303
              MOVWF    019H
              MOVF     01AH,W
              CALL     L0303
              MOVWF    01AH
              XORWF    017H,W
              MOVWF    017H
              SWAPF    01AH,W
              ADDWF    019H,W
              CALL     L0306
              MOVWF    019H
              XORWF    01AH,W
              MOVWF    01AH
              SWAPF    019H,W
              ADDWF    018H,W
              CALL     L0306
              MOVWF    018H
              XORWF    019H,W
              MOVWF    019H
              SWAPF    018H,W
              ADDWF    017H,W
              CALL     L0306
              MOVWF    017H
              XORWF    018H,W
              MOVWF    018H
              SWAPF    017H,W
              ADDWF    01AH,W
              CALL     L0303
              MOVWF    01AH
              XORWF    017H,W
              MOVWF    017H
              SWAPF    01AH,W
              ADDWF    019H,W
              CALL     L0303
              MOVWF    019H
              XORWF    01AH,W
              MOVWF    01AH
              SWAPF    019H,W
              ADDWF    018H,W
              CALL     L0303
              MOVWF    018H
              XORWF    019H,W
              MOVWF    019H
              MOVF     018H,W
              XORWF    017H,W
              MOVWF    018H
              MOVF     018H,W
              CALL     L0306
              XORWF    03CH,F
              MOVF     01AH,W
              CALL     L0306
              XORWF    03DH,F
              MOVF     017H,W
              CALL     L0306
              XORWF    03EH,F
              MOVF     019H,W
              CALL     L0306
              XORWF    03FH,F
              DECF     014H,F
              BTFSS    014H,rb7
              GOTO     L038A
 
              RETURN
 
L038A         MOVF     040H,W
              MOVWF    013H
              MOVF     03CH,W
              MOVWF    040H
              MOVF     013H,W
              MOVWF    03CH
              MOVF     041H,W
              MOVWF    013H
              MOVF     03DH,W
              MOVWF    041H
              MOVF     013H,W
              MOVWF    03DH
              MOVF     042H,W
              MOVWF    013H
              MOVF     03EH,W
              MOVWF    042H
              MOVF     013H,W
              MOVWF    03EH
              MOVF     043H,W
              MOVWF    013H
              MOVF     03FH,W
              MOVWF    043H
              MOVF     013H,W
              MOVWF    03FH
              GOTO     L0322
 
L03A3         MOVF     015H,W
              ADDLW    01H
              ANDLW    0FH
              MOVWF    01BH
              CALL     L030C
              MOVF     INDIR,W
              XORWF    014H,W
              MOVWF    013H
              MOVLW    02H
              SUBWF    01BH,W
              ANDLW    0FH
              CALL     L030C
              MOVF     INDIR,W
              XORWF    013H,W
              CALL     L0303
              MOVWF    013H
              CALL     L030B
              MOVF     INDIR,W
              XORWF    013H,W
              MOVWF    INDIR
              RETURN
 
L03B8         BSF      STATUS,RP0
              BSF      EEDATA,rb2
              MOVLW    055H
              MOVWF    EEADR
              MOVLW    0AAH
              MOVWF    EEADR
              BSF      EEDATA,rb1
L03BF         BTFSC    EEDATA,rb1
              GOTO     L03BF
 
              BCF      STATUS,RP0
              RETURN
 
L03C3         BSF      STATUS,RP0
              BSF      EEDATA,rb0
              BCF      STATUS,RP0
              MOVF     EEDATA,W
              RETURN
 
              ORG 2000H
 
              DATA 3FFFH
              DATA 3FFFH
              DATA 3FFFH
              DATA 3FFFH
              DATA 3FFFH
              DATA 3FFFH
              DATA 0560H
              DATA 3FF9H
 
 
              END
